// $Id: LernListen_steigern.cc,v 1.7 2004/11/29 17:26:50 christof Exp $
/*  Midgard Character Generator
 *  Copyright (C) 2001 Malte Thoma
 *  Copyright (C) 2003-2008 Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */  

#include "LernListen.hh"
#include "Abenteurer.hh"
#include "WaffeGrund.hh"
#include "Schrift.hh"
#include "Zauber.hh"
#include "Zauberwerk.hh"
#include "Datenbank.hh"

std::list<cH_MBE> LernListen::get_steigern_MBE(const Abenteurer& A,MBE_T::MBEE was)
{
  std::list<cH_MBE> V_;
  switch(was) {
     case MBE_T::FERTIGKEIT: V_=Datenbank.Fertigkeit; break;
     case MBE_T::WAFFE: V_=Datenbank.Waffe; break;
     case MBE_T::ZAUBER: V_=Datenbank.Zauber; break;
     case MBE_T::SPRACHE: V_=Datenbank.Sprache; break;
     case MBE_T::SCHRIFT: V_=Datenbank.Schrift; break;
     case MBE_T::WAFFEGRUND: V_=Datenbank.WaffeGrund; break;
     case MBE_T::ZAUBERWERK:V_=Datenbank.Zauberwerk; break; 
     default : assert(!"never get here\n");
   }
  std::list<cH_MBE> V;
  for(std::list<cH_MBE>::const_iterator i=V_.begin();i!=V_.end();++i)
   { if (A.lernbar(*i))
       V.push_back(*i);
   }
  return V;
}

std::list<cH_MBE> LernListen::get_steigern_Zauberliste(const Abenteurer& A,
      bool salz,bool beschwoerung, bool alle,bool spruchrolle)
{
  std::list<cH_MBE> L_=get_steigern_MBE(A,MBE_T::ZAUBER);
  std::list<cH_MBE> L;
  for(std::list<cH_MBE>::const_iterator i=L_.begin();i!=L_.end();++i)
   {
     cH_Zauber z(*i);
     if(!alle)
      {
        if (z->Zauberart()=="Zaubersalz"   && !salz ) continue;
        if (z->Zauberart()=="Beschwörung"  && !beschwoerung) continue;
        if (!z->Spruchrolle()              && spruchrolle) continue;
        // maximale Stufe
        std::vector<std::string> standard=z->Standard(A);
        int maxstufe=A.Grad();
        if ((A.Typ1()->Short()=="Ma" 
              && z->get_spezial_zauber_for_magier(A,standard[0]))
            || (A.Typ2()->Short()=="Ma" 
              && z->get_spezial_zauber_for_magier(A,standard[1])))
          ++maxstufe;
        if (A.In()<=10 && maxstufe>2) maxstufe=2;
        else if (A.In()<=30 && maxstufe>4) maxstufe=4;
        if (z->iStufe()>maxstufe) continue;
      }
     if (z->Spruchrolle()) z->setSpruchrolleFaktor(0.1);
     else z->setSpruchrolleFaktor(1);
     L.push_back(*i);
   }
 return L;
}

std::list<cH_MBE> LernListen::get_steigern_ZauberWerkliste(const Abenteurer& A,
     bool alle)
{
  std::list<cH_MBE> L_=get_steigern_MBE(A,MBE_T::ZAUBERWERK);
  std::list<cH_MBE> L;
  for(std::list<cH_MBE>::const_iterator i=L_.begin();i!=L_.end();++i)
   { const cH_Zauberwerk z(*i);
     if(alle) L.push_back(*i); 
     else
      {  if (!z->Voraussetzungen(A.List_Zauber())) continue;
         if (!z->Voraussetzungen_Fertigkeit(A.List_Fertigkeit())) continue;
         L.push_back(*i); 
      }
   }
 return L;
}


void LernListen::shorten_for_GFP(std::list<cH_MBE> &L_,const Abenteurer& A,const int gfp)
{
  std::list<cH_MBE> L;
  for(std::list<cH_MBE>::const_iterator i=L_.begin();i!=L_.end();++i)
   {
     if((*i)->Kosten(A) > gfp) continue;
     L.push_back(*i);
   }
  L_=L;
}

