/*  Midgard Character Generator
 *  Copyright (C) 2001-2002 Malte Thoma
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, U
 */

#include "midgard_CG.hh"
#include <cstring>
#include <libmagus/Ausgabe.hh>

extern Glib::RefPtr<Gdk::Pixbuf> MagusImage(const std::string &name);

#if 0
void midgard_CG::set_wizard(std::string s)
{
//  label_wizard->show();
//  label_wizard->set_text(s);
}
#endif

void midgard_CG::on_neuer_abenteurer_mit_wizard_activate()
{
 on_neuer_charakter_clicked();
  on_wizard_starten_activate();
}

void midgard_CG::on_wizard_starten_activate()
{
 getChar().proxies.werte_eingeben=false;
 getChar().getWizard().getMode()=Wizard::Aktiv;
 getChar().getWizard().restart(getAben());
}

void midgard_CG::on_wizard_beenden_activate()
{//  label_wizard->hide();
// show_wizard_active(false);
}

static const char * wizard_beschreibung[Wizard::MAXSTEPS];
static int wizard_page[Wizard::MAXSTEPS];

static void fill_texte()
{  if (wizard_beschreibung[Wizard::SPEZIES]) return;
   wizard_beschreibung[Wizard::SPEZIES]=
      "Spezies auswählen, dann Eigenschaften auswürfeln";
   wizard_beschreibung[Wizard::GRUNDWERTE]=
                          "Eigenschaften auswürfeln";
   wizard_beschreibung[Wizard::GESCHLECHT]=
                          "Geschlecht und Abenteuertyp auswählen";
   wizard_beschreibung[Wizard::TYP]=
                          "Abenteurertyp wählen";
   wizard_beschreibung[Wizard::STADTLAND]=
                          "Stadt/Land wählen, dann abgeleitete Werte würfeln";
   wizard_beschreibung[Wizard::ABGELEITETEWERTE]=
                          "Abgeleitete Werte würfeln";
   wizard_beschreibung[Wizard::LERNSCHEMA_SEITE]=
                          "Auf die 'Lernschema'-Seite umblättern";
   wizard_beschreibung[Wizard::HERKUNFT]=
                          "Herkunftsland wählen";
   wizard_beschreibung[Wizard::UEBERLEBEN]=
                          "In welchem Geländetyp wird 'Überleben' als universelle Fertigkeit beherrscht?";
   wizard_beschreibung[Wizard::ANGEBORENEFERTIGKEITEN]=
                          "Angeborene Fertigkeiten erwürfeln";
   wizard_beschreibung[Wizard::LERNPUNKTE]=
                          "Lernpunkte auswürfeln";
   wizard_beschreibung[Wizard::WAEHLEN]=
                          "Jetzt Fertigkeiten, Waffen und ev. Zauber in beliebiger"
                          " Reihenfolge lernen (anklicken) bis alle Lernpunkte"
                          " verbraucht sind; anschließend den Beruf wählen.";
   wizard_beschreibung[Wizard::BERUF1]=
                          "Fertigkeit auswählen, die aufgrund der Berufswahl"
                          " gelernt werden kann, danach das Geld auswürfeln.";
   wizard_beschreibung[Wizard::BERUF]=
                          "Berufsfertigkeit aus Liste wählen";
   wizard_beschreibung[Wizard::GELD]=
                          "Geld auswürfeln";
   wizard_beschreibung[Wizard::WAFFEN]=
                          "Waffen auswürfeln";
   wizard_beschreibung[Wizard::RUESTUNG]=
                          "Rüstung auswürfeln";
   wizard_beschreibung[Wizard::AUSRUESTUNG]=
                          "Ausrüstung auswürfeln";
   wizard_beschreibung[Wizard::SPEZIALWAFFE]=
                          "Spezialwaffe wählen (anklicken)";
   wizard_beschreibung[Wizard::SPEZIALGEBIET]=
                          "Magier sollten ein Spezialgebiet wählen (das kann aber auch später geschehen)";
   wizard_beschreibung[Wizard::NAMEN]=
                          "Namen vergeben (Eingabe mit 'Enter' abschließen)";
   wizard_beschreibung[Wizard::SPEICHERN]=
                          "Bitte fertigen Abenteurer als nächstes abspeichern";
   for (unsigned i=0;i<Wizard::MAXSTEPS;++i)
      wizard_page[i]=midgard_CG::NOPAGE;
   wizard_page[Wizard::SPEZIES]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::GRUNDWERTE]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::GESCHLECHT]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::TYP]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::STADTLAND]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::ABGELEITETEWERTE]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::LERNSCHEMA_SEITE]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::HERKUNFT]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::UEBERLEBEN]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::ANGEBORENEFERTIGKEITEN]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::LERNPUNKTE]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::WAEHLEN]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::BERUF1]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::BERUF]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::GELD]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::WAFFEN]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::RUESTUNG]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::AUSRUESTUNG]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::SPEZIALWAFFE]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::SPEZIALGEBIET]=midgard_CG::PAGE_LERNEN;
   wizard_page[Wizard::NAMEN]=midgard_CG::PAGE_GRUNDWERTE;
   wizard_page[Wizard::SPEICHERN]=midgard_CG::PAGE_GRUNDWERTE;
}

// actions which might cause other signals to emit should reside in this delayed function
bool midgard_CG::wizard_changed_delayed()
{
//  ManuProC::Trace _t(trace_channel,__FUNCTION__,aktiver.getWizard().Value());
  if (aktiver.getWizard().getMode().Value()==Wizard::Aktiv)
  {  	Wizard::esteps e=aktiver.proxies.wizard.Value();
	 if(e==Wizard::FERTIG)
	    on_wizard_beenden_activate();
	 else if(e==Wizard::SPEICHERN)
	   xml_export_auswahl();
  }
  return false;
}

void midgard_CG::wizard_changed(gpointer x)
{
//  ManuProC::Trace _t(trace_channel,__FUNCTION__,aktiver.getWizard().Value());
   if (aktiver.proxies.wizard.matches(x))
   {  if (aktiver.getWizard().getMode().Value()==Wizard::Aus)
      {
	 pixmap_status_wizard->set(MagusImage("Wizard_off.png"));
      }
      else if (aktiver.getWizard().getMode().Value()>=Wizard::Hints)
      {
	 pixmap_status_wizard->set(MagusImage("MAGUS_Logo_Tiny.light"));
	 if (!wizard_beschreibung[Wizard::SPEZIES]) fill_texte();
         if (wizard_beschreibung[aktiver.proxies.wizard.Value()])
           Ausgabe(Ausgabe::ActionNeeded,wizard_beschreibung[aktiver.proxies.wizard.Value()]);
      }
      // aktiv mithelfen?
      else if (aktiver.getWizard().getMode().Value()==Wizard::Aktiv)
      {
	pixmap_status_wizard->set(MagusImage("MAGUS_Logo_Tiny.xpm"));
	Wizard::esteps e=aktiver.proxies.wizard.Value();
	if (e==Wizard::FERTIG || e==Wizard::SPEICHERN)
	  Glib::signal_timeout().connect(sigc::mem_fun(*this,&midgard_CG::wizard_changed_delayed), 100);
      }
   }
}

bool midgard_CG::wizard_aktiv_button_release_event(GdkEventButton *ev)
{  if (getChar()->getWizard().getMode().Value()!=Wizard::Aktiv)
      on_wizard_starten_activate();
   return true;
}
