/*  MAGuS: Midgard Abenteurer Generieren Und Steigern
 *  Copyright (C) 2002 Malte Thoma
 *  Copyright (C) 2004-2007 Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "config.h"
#include "table_lernschema.hh"
#include "midgard_CG.hh"
#include "class_SimpleTree.hh"
#include "Fertigkeiten.hh"
#include <Misc/itos.h>
#include "WaffeGrund.hh"
#include <SelectMatching.h>
#include "KiDo.hh"
#include "Sprache.hh"
#include "LernListen.hh"
#include <libmagus/Random.hh>
#include <libmagus/Ausgabe.hh>
#include "DialogAuswahl.hh"
#include <Misc/Trace.h>

void table_lernschema::refresh()
{
   if (hauptfenster->get_current_page()!=midgard_CG::PAGE_LERNEN) return;
  show_gelerntes();
  zeige_werte();
}

bool table_lernschema::wizard_changed_delayed()
{
//  ManuProC::Trace _t(trace_channel,__FUNCTION__,vabenteurer->proxies.wizard.Value());
  printf("%s %d %d\n", __FUNCTION__, vabenteurer->proxies.wizard_mode.Value(), vabenteurer->proxies.wizard.Value());
  if (vabenteurer->proxies.wizard_mode.Value()==Wizard::Aktiv)
  {
    switch (vabenteurer->proxies.wizard.Value())
    { case Wizard::HERKUNFT:  on_herkunftsland_clicked(); break;
      case Wizard::ANGEBORENEFERTIGKEITEN:  on_angeborene_fertigkeit_clicked(); break;
      case Wizard::BERUF1: on_button_beruf(); break;
    }
  }
  else if (vabenteurer->proxies.wizard_mode.Value()==Wizard::Sensitive)
  {
    switch (vabenteurer->proxies.wizard.Value())
    { case Wizard::BERUF1: button_beruf->grab_focus(); break;
    }
  }

//    if (vabenteurer->proxies.wizard.Value()!=Wizard::BERUF1
//    	&& vabenteurer->proxies.wizard_mode.Value()>Wizard::Hints)
//         vbox_berufsname->hide();
//      else
//      {  if (vabenteurer->proxies.werte_eingeben.Value())
//            vbox_berufsname->show();
//         else
//
//      }
  return false;
}

void table_lernschema::wizard_changed(gpointer p)
{ if (vabenteurer->proxies.wizard.Value()!=Wizard::BERUF1
	&& vabenteurer->proxies.wizard_mode.Value()>Wizard::Hints)
     vbox_berufsname->hide();
  else
  {  if (vabenteurer->proxies.werte_eingeben.Value())
        vbox_berufsname->show();
     else
       Glib::signal_timeout().connect(sigc::mem_fun(*this,&table_lernschema::wizard_changed_delayed), 100);
  }

  bool always_sens=vabenteurer->proxies.wizard_mode.Value()<=Wizard::Hints
       || bool(vabenteurer->getAbenteurer().getOptionen().OptionenCheck(Optionen::NSC_only).active);
  button_herkunft->set_sensitive(always_sens
  	|| vabenteurer->proxies.wizard.Value()==Wizard::HERKUNFT);
  button_angeborene_fert->set_sensitive(always_sens
  	|| vabenteurer->proxies.wizard.Value()==Wizard::ANGEBORENEFERTIGKEITEN);
  togglebutton_lernpunkte_edit->set_sensitive(always_sens
  	|| vabenteurer->proxies.wizard.Value()==Wizard::LERNPUNKTE);
  button_sensitive(always_sens
  	|| vabenteurer->proxies.wizard.Value()==Wizard::WAEHLEN);
  button_kido_auswahl->set_sensitive(always_sens
  	|| vabenteurer->proxies.wizard.Value()==Wizard::KIDO_STIL);

  if (vabenteurer->proxies.wizard_mode.Value()==Wizard::Aktiv)
  {
    Wizard::esteps e=vabenteurer->proxies.wizard.Value();
    if (e==Wizard::HERKUNFT || e==Wizard::ANGEBORENEFERTIGKEITEN)
      Glib::signal_timeout().connect(sigc::mem_fun(*this,&table_lernschema::wizard_changed_delayed), 100);
  }
}

void table_lernschema::init(midgard_CG *h)
{
  hauptfenster=h;
  vabenteurer=&h->getChar();
//  vabenteurer->getLernpunkte().MaxKido()=0;
//  gwr_auswahl=ENone;
  vabenteurer->signal_anderer_abenteurer().connect(sigc::mem_fun(*this,&table_lernschema::refresh));
  vabenteurer->proxies.undo_changed.connect(sigc::mem_fun(*this,&table_lernschema::refresh));
  h->signal_any_wizard_change().connect(sigc::mem_fun(*this,&table_lernschema::wizard_changed));
}

table_lernschema::table_lernschema(GlademmData *_data)
          : table_lernschema_glade(_data), hauptfenster(),
            gwr_auswahl(ENone),
            tree_lernschema(),Beruf_tree(),tree_angeb_fert(),
            tree_kido_lernschema(),
            tree_waffen_lernschema(), ausgewaehlt()
{
}

void table_lernschema::on_button_waffe_trans_clicked()
{
 if(vabenteurer->getLernpunkte().getLernpunkte().Waffen()>0)
   {
     vabenteurer->getLernpunkte().getLernpunkte().addWaffen(-1);
     vabenteurer->getLernpunkte().getLernpunkte().addUnge(+1);
   }
 zeige_lernpunkte();
}

void table_lernschema::on_button_fach_trans_clicked()
{
   if(vabenteurer->getLernpunkte().getLernpunkte().Fach()>0)
   {
     vabenteurer->getLernpunkte().getLernpunkte().addFach(-1);
     vabenteurer->getLernpunkte().getLernpunkte().addUnge(+1);
   }
 zeige_lernpunkte();
}

bool table_lernschema::on_spinbutton_fach_focus_out_event(GdkEventFocus *ev)
{  set_lernpunkte(); return 0;}
bool table_lernschema::on_spinbutton_allgemein_focus_out_event(GdkEventFocus *ev)
{  set_lernpunkte(); return 0;}
bool table_lernschema::on_spinbutton_waffen_focus_out_event(GdkEventFocus *ev)
{  set_lernpunkte(); return 0;}
bool table_lernschema::on_spinbutton_zaubern_focus_out_event(GdkEventFocus *ev)
{  set_lernpunkte(); return 0; }
bool table_lernschema::on_spinbutton_unge_focus_out_event(GdkEventFocus *ev)
{  set_lernpunkte(); return 0; }

bool table_lernschema::on_spinbutton_fach_focus_in_event(GdkEventFocus *ev)
{ spinbutton_fach->select_region(0,-1);   return false;}
bool table_lernschema::on_spinbutton_allgemein_focus_in_event(GdkEventFocus *ev)
{ spinbutton_allgemein->select_region(0,-1);   return false;}
bool table_lernschema::on_spinbutton_unge_focus_in_event(GdkEventFocus *ev)
{ spinbutton_unge->select_region(0,-1);   return false;}
bool table_lernschema::on_spinbutton_waffen_focus_in_event(GdkEventFocus *ev)
{ spinbutton_waffen->select_region(0,-1);   return false;}
bool table_lernschema::on_spinbutton_zaubern_focus_in_event(GdkEventFocus *ev)
{ spinbutton_zauber->select_region(0,-1);   return false;}

void table_lernschema::on_spinbutton_fach_activate()
{ set_lernpunkte(); spinbutton_allgemein->grab_focus();}
void table_lernschema::on_spinbutton_allgemein_activate()
{ set_lernpunkte(); spinbutton_unge->grab_focus();}
void table_lernschema::on_spinbutton_unge_activate()
{ set_lernpunkte(); spinbutton_waffen->grab_focus();}
void table_lernschema::on_spinbutton_waffen_activate()
{ set_lernpunkte(); spinbutton_zauber->grab_focus();}
void table_lernschema::on_spinbutton_zaubern_activate()
{ set_lernpunkte(); togglebutton_lernpunkte_edit->set_active(false);}

void table_lernschema::set_lernpunkte()
{
  spinbutton_unge->update();
  vabenteurer->getLernpunkte().getLernpunkte().setUnge(spinbutton_unge->get_value_as_int());
  spinbutton_fach->update();
  vabenteurer->getLernpunkte().getLernpunkte().setFach(spinbutton_fach->get_value_as_int());
  spinbutton_allgemein->update();
  vabenteurer->getLernpunkte().getLernpunkte().setAllgemein(spinbutton_allgemein->get_value_as_int());
  spinbutton_waffen->update();
  vabenteurer->getLernpunkte().getLernpunkte().setWaffen(spinbutton_waffen->get_value_as_int());
  spinbutton_zauber->update();
  vabenteurer->getLernpunkte().getLernpunkte().setZauber(spinbutton_zauber->get_value_as_int());
  on_lernliste_wahl_toggled();
  zeige_werte();
}



void table_lernschema::on_lernliste_wahl_toggled()
{
   if(button_zauber->get_active())
   {
     if (hauptfenster->getAben().Spezialgebiet()->Spezial2().empty() &&
         hauptfenster->getAben().Typ1()->Short()=="eBe")
      {
         Ausgabe(Ausgabe::Error,"Erst Primär- und Sekundärelement wählen");
         return;
      }
   }
 show_lernschema();
}



void table_lernschema::on_button_waffen_clicked()
{
  if(hauptfenster->getAben().Typ1()->Kultwaffe() &&hauptfenster->getAben().List_Waffen().empty())
   {
     Ausgabe(Ausgabe::ActionNeeded,hauptfenster->getAben().Typ1()->Name(hauptfenster->getAben().Geschlecht())+" m��ssen als erstes ihre Kultwaffe w��hlen; fehlende Lernpunkte werden geschenkt.");
     togglebutton_teure_anzeigen->set_active(true);
   }
  button_lernschema_waffen->set_sensitive(true);
}


//#warning dies muesste in libmagus (normales Verlernen)
void table_lernschema::on_tree_gelerntes_leaf_selected(cH_RowDataBase d)
{
  if(!togglebutton_gelernt_verlernen->get_active()) return;
  hauptfenster->getChar()->begin_undo();
  Handle<Data_SimpleTree const> dt=d.cast_dynamic<Data_SimpleTree const>();
  H_MBEm MBE = dt->getMBE();
  bool verlernt=false;
  bool fehler = hauptfenster->getAben().ReduzierenVerlernen(MBE, verlernt);
  if (fehler) hauptfenster->getChar()->cancel_undo();
  else if (verlernt)
	  hauptfenster->getChar()->name_undo((*MBE)->What_str()+" "+(*MBE)->Name()+" verlernt");
  else
	  hauptfenster->getChar()->name_undo((*MBE)->What_str()+" "+(*MBE)->Name()+" reduziert");

  if((*MBE).What()==MBE_T::WAFFEBESITZ)
	    show_WaffenBesitz_lernschema();
  else
	    show_lernschema();
  show_gelerntes();
}

// ungelernte Fertigkeit angeklickt ??
void table_lernschema::on_tree_lernschema_leaf_selected(cH_RowDataBase d, bool &processed)
{
  hauptfenster->getChar()->begin_undo();
  const Data_SimpleTree *dt=dynamic_cast<const Data_SimpleTree*>(&*d);
  H_LSE MBE = dt->getLSE();
  Abenteurer &A=hauptfenster->getAben();
  if(MBE->Gelernt())
   {
     Ausgabe(Ausgabe::Error,"Diese Fertigkeit ist schon gelernt");
     tree_lernschema->get_selection()->unselect_all();
     hauptfenster->getChar()->cancel_undo();
     return;
   }
  H_MBEm gel= A.Erlernen(MBE);
  if (!gel)
	hauptfenster->getChar()->cancel_undo();
  else
    hauptfenster->getChar()->name_undo((*MBE)->What_str()+" "+(*MBE)->Name()+" gelernt");
  processed=true;
  show_lernschema();
  show_gelerntes();
//#warning weg?
  if(frame_lernschema_zusatz->is_visible()) scrolledwindow_lernen->set_sensitive(false);
}



void table_lernschema::on_herkunftsland_clicked()
{
  //cH_MBE Dummy=&*cH_Fertigkeit("",true);
  if (hauptfenster->getAben().Herkunft()->Name().empty())
  {
	  hauptfenster->getAben().HerkunftWaehlen();
  }
  if (!hauptfenster->getAben().Herkunft()->Name().empty() && hauptfenster->getAben().Muttersprache().empty())
  {
	  hauptfenster->getAben().MutterspracheWaehlen();
  }
  hauptfenster->getAben().UeberlebenWaehlen();

  hauptfenster->getChar().getWizard().done(Wizard::HERKUNFT,hauptfenster->getAben());
  zeige_werte();
  show_gelerntes();
}

void table_lernschema::lernpflichten_info()
{
  std::string t1=hauptfenster->getAben().Typ1()->getLernpflichtenInfo(hauptfenster->getAben().Herkunft());
  std::string t2=hauptfenster->getAben().Typ2()->getLernpflichtenInfo(hauptfenster->getAben().Herkunft());
  if(!t1.empty() || !t2.empty())
      Ausgabe(Ausgabe::ActionNeeded,t1+"\n"+t2);
}

#include "Zufall.hh"
void table_lernschema::on_lernpunkte_wuerfeln_clicked()
{ lernpflichten_info();
  Zufall::Lernpunkte_wuerfeln(hauptfenster->getAben());
  hauptfenster->getChar().getWizard().done(Wizard::LERNPUNKTE,hauptfenster->getAben());
  show_gelerntes();

  zeige_lernpunkte();

  button_sensitive(true);
  on_lernliste_wahl_toggled();
}

void table_lernschema::button_sensitive(bool b)
{
  button_fachkenntnisse->set_sensitive(b);
  button_allgemeinwissen->set_sensitive(b);
  button_untyp_fertigkeiten->set_sensitive(b);
  button_waffen->set_sensitive(b);
//#warning Christof: Warum stürzt das Programm ab, wenn man das 'b &&' wegnimmt?
  if(hauptfenster && hauptfenster->getAben().is_mage())
      button_zauber->set_sensitive(b);
  button_beruf->set_sensitive(b);
  button_lernschema_geld->set_sensitive(b);
  button_lernschema_waffen->set_sensitive(b);
  button_ruestung->set_sensitive(b);
  button_ausruestung->set_sensitive(b);
}



void table_lernschema::on_togglebutton_lernpunkte_edit_toggled()
{  if (!hauptfenster->getChar().proxies.werte_eingeben.Value())
      on_lernpunkte_wuerfeln_clicked();
   else edit_lernpunkte(togglebutton_lernpunkte_edit->get_active());
}

void table_lernschema::edit_lernpunkte(bool b)
{
 spinbutton_fach->set_sensitive(b);
 spinbutton_allgemein->set_sensitive(b);
 spinbutton_unge->set_sensitive(b);
 spinbutton_waffen->set_sensitive(b);
 spinbutton_zauber->set_sensitive(b);
 if(b) table_berufsprozent->show();
 else  table_berufsprozent->hide();
}


void table_lernschema::on_button_lernschema_geld()
{
  hauptfenster->getChar().getWizard().done(Wizard::GELD,hauptfenster->getAben());
  if(!hauptfenster->getAben().getOptionen().OptionenCheck(Optionen::NSC_only).active)
     button_lernschema_geld->set_sensitive(false);
  if (hauptfenster->getChar().proxies.werte_eingeben.Value())
  {  gwr_auswahl=EGeld1;
     set_gwr_eingabe();
  }
  else
  {  hauptfenster->getAben().setGeld(0,0,0);
     geld_wuerfeln() ;
  }
}

void table_lernschema::geld_wuerfeln()
{
     vabenteurer->getLernpunkte().getVGeldwurf().clear();
     for(int i=0;i<3;++i) vabenteurer->getLernpunkte().getVGeldwurf().push_back(Random::integer(1,6));
     lernschema_geld_wuerfeln(vabenteurer->getLernpunkte().getVGeldwurf());
}

void table_lernschema::set_gwr_eingabe()
{
  switch (gwr_auswahl) {
    case ENone : assert(!"never get here"); break;
    case EWaffen : label_gwr->set_text("%-Wurf für\nWaffen"); break;
    case ERuestung: label_gwr->set_text("%-Wurf für\nRüstung"); break;
    case EGeld1 :  label_gwr->set_text("1. W6-Wurf für\nGeld"); break;
    case EGeld2 :  label_gwr->set_text("2. W6-Wurf für\nGeld"); break;
    case EGeld3 :  label_gwr->set_text("3. W6-Wurf für\nGeld"); break;
   }
  if(gwr_auswahl==EWaffen || gwr_auswahl==ERuestung)
    spinbutton_waffen_lernschema->get_adjustment()->set_upper(100);
  else
    spinbutton_waffen_lernschema->get_adjustment()->set_upper(6);

  table_waffen_lernschema_eingabe->show();
  spinbutton_waffen_lernschema->select_region(0,-1);
  spinbutton_waffen_lernschema->grab_focus();
}


void table_lernschema::lernschema_geld_wuerfeln(const std::vector<int>& VGeldwurf)
{
 assert(VGeldwurf.size()==3);
 int igold=0;
 igold=VGeldwurf[0]+VGeldwurf[1]+VGeldwurf[2];
 if      (hauptfenster->getAben().Typ1()->Geld() == 1) igold-=3;
 else if (hauptfenster->getAben().Typ1()->Geld() == 2) igold+=0;
 else if (hauptfenster->getAben().Typ1()->Geld() == 3) igold+=6;
 else if (hauptfenster->getAben().Typ1()->Geld() == 4) igold+=3;

 if(hauptfenster->getAben().Stand()=="Adel" ) igold*=2;
 if(hauptfenster->getAben().Stand()=="Unfrei" ) igold/=2;
 if(VGeldwurf[0]==VGeldwurf[1] && VGeldwurf[1]==VGeldwurf[2]) igold += 100;

 std::string strinfo ="Beim Auswürfeln von Geld wurden "
   +itos(VGeldwurf[0])+"  "+itos(VGeldwurf[1])+"  "+itos(VGeldwurf[2])+" gewürfelt ==> "
   +itos(igold)+" Gold";
 Ausgabe(Ausgabe::Log,strinfo);
 hauptfenster->getAben().addGold(igold);
 zeige_werte();
}


void table_lernschema::on_button_ruestung()
{
  hauptfenster->getChar().getWizard().done(Wizard::RUESTUNG,hauptfenster->getAben());
  if(!hauptfenster->getAben().getOptionen().OptionenCheck(Optionen::NSC_only).active)
     button_ruestung->set_sensitive(false);
   if (!hauptfenster->getChar().proxies.werte_eingeben.Value())
   {
     int wurf = Random::integer(1,100);
     on_button_ruestung_clicked(wurf);
   }
   else
   { //manage (new Window_ruestung(hauptfenster->getWerte(),hauptfenster,Datenbank));
     gwr_auswahl=ERuestung;
     set_gwr_eingabe();
   }
}

void table_lernschema::on_button_ruestung_clicked(int wurf)
{
  std::string rue;
  if (hauptfenster->getAben().Typ1()->Ruestung() == 1)
   {
      if ( 1 <= wurf && wurf  <= 10 ) rue = "OR" ;
      if (11 <= wurf && wurf  <= 20 ) rue = "TR" ;
      if (21 <= wurf && wurf  <= 30 ) rue = "TR" ;
      if (31 <= wurf && wurf  <= 60 ) rue = "LR" ;
      if (61 <= wurf && wurf  <= 80 ) rue = "LR" ;
      if (81 <= wurf && wurf  <= 95 ) rue = "LR" ;
      if (96 <= wurf && wurf  <= 100) rue = "LR" ;
   }
  if (hauptfenster->getAben().Typ1()->Ruestung()== 2)
   {
      if ( 1 <= wurf && wurf  <= 10 ) rue = "OR" ;
      if (11 <= wurf && wurf  <= 20 ) rue = "TR" ;
      if (21 <= wurf && wurf  <= 30 ) rue = "LR" ;
      if (31 <= wurf && wurf  <= 60 ) rue = "LR" ;
      if (61 <= wurf && wurf  <= 80 ) rue = "KR" ;
      if (81 <= wurf && wurf  <= 95 ) rue = "KR" ;
      if (96 <= wurf && wurf  <= 100) rue = "KR" ;
   }
  if (hauptfenster->getAben().Typ1()->Ruestung()== 3)
   {
      if ( 1 <= wurf && wurf  <= 10 ) rue = "OR" ;
      if (11 <= wurf && wurf  <= 20 ) rue = "TR" ;
      if (21 <= wurf && wurf  <= 30 ) rue = "LR" ;
      if (31 <= wurf && wurf  <= 60 ) rue = "KR" ;
      if (61 <= wurf && wurf  <= 80 ) rue = "KR" ;
      if (81 <= wurf && wurf  <= 95 ) rue = "KR" ;
      if (96 <= wurf && wurf  <= 100) rue = "PR" ;
   }
  if (hauptfenster->getAben().Typ1()->Ruestung()== 4)
   {
      if ( 1 <= wurf && wurf  <= 10 ) rue = "OR" ;
      if (11 <= wurf && wurf  <= 20 ) rue = "OR" ;
      if (21 <= wurf && wurf  <= 30 ) rue = "OR" ;
      if (31 <= wurf && wurf  <= 60 ) rue = "TR" ;
      if (61 <= wurf && wurf  <= 80 ) rue = "TR" ;
      if (81 <= wurf && wurf  <= 95 ) rue = "LR" ;
      if (96 <= wurf && wurf  <= 100) rue = "LR" ;
   }
  if(hauptfenster->getAben().Typ1()->Short()=="Fi") rue="KR";
  hauptfenster->getAben().setRuestung1(rue);
  Ausgabe(Ausgabe::Error,"Beim Auswürfeln der Rüstung wurde eine "+itos(wurf)+" gewürfelt "
             "==> " + hauptfenster->getAben().Ruestung()->Long());
  zeige_werte();
}


void table_lernschema::on_button_ausruestung()
{
  ausruestung_setzen();
}

void table_lernschema::ausruestung_setzen()
{
  hauptfenster->getChar().getWizard().done(Wizard::AUSRUESTUNG,hauptfenster->getAben());
  if(!hauptfenster->getAben().getOptionen().OptionenCheck(Optionen::NSC_only).active)
     button_ausruestung->set_sensitive(false);

  hauptfenster->getAben().setStandardAusruestung();
//  AusruestungBaum &Rucksack=hauptfenster->getAben().getBesitz();
//  setFertigkeitenAusruestung(Rucksack);
  setFertigkeitenAusruestung();
}


void table_lernschema::on_togglebutton_teure_anzeigen_toggled()
{
 on_lernliste_wahl_toggled();
}

void table_lernschema::on_togglebutton_gelernte_anzeigen_toggled()
{
 on_lernliste_wahl_toggled();
}

void table_lernschema::zeige_werte()
{
  zeige_lernpunkte();
  label_ruestung_lernschema->set_text(hauptfenster->getAben().Ruestung()->Long());
  label_herkunft_lernschema->set_text(hauptfenster->getAben().Herkunft()->Name());
  fertig_typ->set_text(hauptfenster->getAben().STyp());

  // Spezialwaffe anzeigen?
 if (hauptfenster->getAben().Typ1()->Spezialwaffe() ||
      hauptfenster->getAben().Typ2()->Spezialwaffe())
    togglebutton_spezialwaffe->show();
 else
   { togglebutton_spezialwaffe->set_active(false);
     togglebutton_spezialwaffe->hide(); }


 // Magie anzeigen?
 if (hauptfenster->getAben().is_mage())
   { if ( hauptfenster->getAben().Typ1()->Spezialgebiet() ||
          hauptfenster->getAben().Typ2()->Spezialgebiet() )
     show_magier_spezialgebiet(true);
     else show_magier_spezialgebiet(false);
     if(!hauptfenster->getAben().Spezialgebiet()->Name().empty())
       combo_magier_spezialgebiet->get_entry()->set_text(hauptfenster->getAben().Spezialgebiet()->Name());
     button_zauber->set_sensitive(true);
   }
 else
   {
     show_magier_spezialgebiet(false);
     button_zauber->set_sensitive(false);
   }
 // KiDo anzeigen?
 if(H_MBEm(&*cH_Fertigkeit("KiDo"))->ist_gelernt(hauptfenster->getAben().List_Fertigkeit()))
   {
     KiDo_Stile kd;
     combo_kido_stil->set_popdown_strings(kd.getVStile());
     frame_KiDo_lernschema->show();
   }
 else
   {
     frame_KiDo_lernschema->hide();
   }
 // KiDo Stil setzen
 combo_kido_stil->get_entry()->set_text(hauptfenster->getAben().Spezialisierung());
}

void table_lernschema::zeige_lernpunkte()
{
 spinbutton_fach->set_value(vabenteurer->getLernpunkte().getLernpunkte().Fach());
 spinbutton_allgemein->set_value(vabenteurer->getLernpunkte().getLernpunkte().Allgemein());
 spinbutton_unge->set_value(vabenteurer->getLernpunkte().getLernpunkte().Unge());
 spinbutton_waffen->set_value(vabenteurer->getLernpunkte().getLernpunkte().Waffen());
 spinbutton_zauber->set_value(vabenteurer->getLernpunkte().getLernpunkte().Zauber());
}

void table_lernschema::show_gelerntes()
{
  zeige_lernpunkte();

  std::list<H_MBEm> FL;
  std::list<std::list<H_MBEm> > LL;
  LL.push_back(hauptfenster->getAben().List_Fertigkeit_ang());
  LL.push_back(hauptfenster->getAben().List_Fertigkeit());
  LL.push_back(hauptfenster->getAben().List_Waffen());
  LL.push_back(hauptfenster->getAben().List_Zauber());
  LL.push_back(hauptfenster->getAben().List_Zauberwerk());
  LL.push_back(hauptfenster->getAben().List_Kido());
  LL.push_back(hauptfenster->getAben().List_WaffenGrund());
  LL.push_back(hauptfenster->getAben().List_Sprache());
  LL.push_back(hauptfenster->getAben().List_Schrift());
  LL.push_back(hauptfenster->getAben().List_Beruf());
  LL.push_back(hauptfenster->getAben().Sinne());
  {
  std::list<H_MBEm> temp;
  for(std::list<H_WaffeBesitz>::iterator i=hauptfenster->getAben().List_Waffen_besitz().begin();i!=hauptfenster->getAben().List_Waffen_besitz().end();++i)
      temp.push_back(H_MBEm(&**i));
  LL.push_back(temp);
  }
  for(std::list<std::list<H_MBEm> >::const_iterator i=LL.begin();i!=LL.end();++i)
    for (std::list<H_MBEm>::const_iterator j=i->begin();j!=i->end();++j)
      FL.push_back(*j);
  MidgardBasicTree::show_list_in_tree(FL,tree_gelerntes,hauptfenster->getChar().actualIterator());

  tree_gelerntes->Expand_recursively();
  scrolledwindow_lernen->set_sensitive(true);
}


void table_lernschema::show_lernschema()
{
  Abenteurer &A=hauptfenster->getAben();
  if(button_kido_auswahl->get_active()) return;
  clean_lernschema_trees();
  tree_lernschema = Gtk::manage(new MidgardBasicTree(MidgardBasicTree::LERNSCHEMA));
  tree_lernschema->signal_clicked().connect(sigc::mem_fun(*static_cast<class table_lernschema*>(this), &table_lernschema::on_tree_lernschema_leaf_selected));

  MBE_T::MBEE what;
  MBEm_T::wie_erlernt::lernen_t liste=MBEm_T::wie_erlernt::separat;
//  std::string fert;
  if(button_waffen->get_active())
    {  what=MBE_T::WAFFE;
       label_lernschma_titel->set_text("Waffen");
    }
  else if(button_zauber->get_active())
    {  what=MBE_T::ZAUBER;
       label_lernschma_titel->set_text("Zauber");
    }
  else
    {  what=MBE_T::FERTIGKEIT;
       if(button_fachkenntnisse->get_active())
         {  liste=MBEm_T::wie_erlernt::fachkenntnis;
            label_lernschma_titel->set_text("Fachkenntnisse");
         }
        else if(button_untyp_fertigkeiten->get_active())
         {  liste=MBEm_T::wie_erlernt::ungewoehnlich;
            label_lernschma_titel->set_text("Ungewöhnliche Fertigkeiten");
         }
        else
         {  liste=MBEm_T::wie_erlernt::allgemeinwissen;
            label_lernschma_titel->set_text("Allgemeinwissen ("+
                  A.Stadt_Land_str()+")");
         }
   }

  std::list<H_LSE> newlist;
//  std::list<H_MBEm> LW;
  if(liste==MBEm_T::wie_erlernt::ungewoehnlich || liste==MBEm_T::wie_erlernt::allgemeinwissen)
   {
    std::list<H_LSE> L;
    if     (liste==MBEm_T::wie_erlernt::ungewoehnlich) L=LernListen::getMBEm(A,LernListen::lUnge);
    else if(liste==MBEm_T::wie_erlernt::allgemeinwissen) L=LernListen::getMBEm(A,LernListen::lAllg);
//    LernListen::filterLearned(L);
    for(std::list<H_LSE>::iterator i=L.begin();i!=L.end();++i)
     {
       int lp=(*i)->Lernpunkte();
       if(liste==MBEm_T::wie_erlernt::allgemeinwissen)
        {
          if(!togglebutton_teure_anzeigen->get_active() && lp>vabenteurer->getLernpunkte().getLernpunkte().Allgemein())
               continue;
        }
       if(liste==MBEm_T::wie_erlernt::ungewoehnlich)
       if(!togglebutton_teure_anzeigen->get_active() && lp>vabenteurer->getLernpunkte().getLernpunkte().Unge())
            continue;
       if(lp > 10  ) continue;

       if(!(*(*i))->Voraussetzung(A)) continue;
//       if ((*(*i))->ist_gelernt(list_FertigkeitZusaetze)) (*i)->setGelernt(true); else
       (*i)->setGelernt((*i)->ist_gelernt(A)); //(*i)->setZusatz(MBE_T::st_zusatz(""));}
//       if((*(*i))->Name()=="Landeskunde (Heimat)" && (*(*i))->ist_gelernt(list_FertigkeitZusaetze)) (*i)->setGelernt(true);
       if((*i)->Gelernt()&&!togglebutton_gelernte_anzeigen->get_active()) continue;
       newlist.push_back(*i);
     }
   }
  if(liste==MBEm_T::wie_erlernt::fachkenntnis) // Freiwillige Speziesfertigkeiten
   {
     std::list<H_LSE> LW=A.Spezies()->getFreiwilligeFertigkeiten(A);
     for(std::list<H_LSE>::iterator i=LW.begin();i!=LW.end();++i)
      {
       if ((*i)->getListe()!=MBEm_T::wie_erlernt::fachkenntnis)
       {
	 H_LSE h=*i;
	 std::cerr << __FILE__ << ':' << __LINE__ << ' ' << h->getMBE()->Name() << '-' << h->getListe() << '\n';
	 continue;
       }
       assert((*i)->getListe()==MBEm_T::wie_erlernt::fachkenntnis);
       bool gelernt=(*i)->ist_gelernt(A);
       bool zuteuer=false;
//       if ((*i)->ist_gelernt(A.List_Fertigkeit())) gelernt=true;
//       if ((*(*i))->ist_gelernt(list_FertigkeitZusaetze)) gelernt=true;
       if((*i)->Lernpunkte() > vabenteurer->getLernpunkte().getLernpunkte().Fach() ) zuteuer=true;
       if(zuteuer && !togglebutton_teure_anzeigen->get_active()) continue;
       if(gelernt && !togglebutton_gelernte_anzeigen->get_active()) continue;
       if(gelernt) (*i)->setGelernt(true);
       newlist.push_back(*i);
     }
   }
  if(liste!=MBEm_T::wie_erlernt::ungewoehnlich && liste!=MBEm_T::wie_erlernt::allgemeinwissen)
    {
    std::list<H_LSE> L;
    if(what==MBE_T::WAFFE) L=LernListen::getMBEm(A,LernListen::lWaff);
    else if(what==MBE_T::ZAUBER)L=LernListen::getMBEm(A,LernListen::lZaub);
    else if(what==MBE_T::FERTIGKEIT)L=LernListen::getMBEm(A,LernListen::lFach);
    for(std::list<H_LSE>::iterator i=L.begin();i!=L.end();++i)
     {
       bool gelernt=false;
       if((*i)->Lernpunkte() > 10  ) continue;
       if(what==MBE_T::WAFFE)
        {
          if ((*i)->ist_gelernt(A.List_Waffen())) gelernt=true;
          if (!(*(*i))->Voraussetzung(A)) continue ;
          if(A.Typ1()->Kultwaffe() &&A.List_Waffen().empty())
            Ausgabe(Ausgabe::Error,A.Typ1()->Name(A.Geschlecht())+" müssen als erstes ihre Kultwaffe wählen; fehlende Lernpunkte werden geschenkt.");
        }
       else if(what==MBE_T::ZAUBER)
        {
          if ((*i)->ist_gelernt(A.List_Zauber()) )  gelernt=true;
        }
       else if(what==MBE_T::FERTIGKEIT)
        {
          if ((*i)->ist_gelernt(newlist)) continue ; // Speziesfertigkeiten nicht doppelt anzeigen
          if (!(*(*i))->Voraussetzung(A)) continue ;
          if ((*i)->ist_gelernt(hauptfenster->getAben().List_Fertigkeit())) gelernt=true;
//          CP: was ist das????
//          if ((*(*i))->ist_gelernt(list_FertigkeitZusaetze)) gelernt=true;
          assert((*i)->getListe()==MBEm_T::wie_erlernt::fachkenntnis);
        }

       bool zuteuer=false;
       if(what==MBE_T::WAFFE)
         { if((*i)->Lernpunkte() > vabenteurer->getLernpunkte().getLernpunkte().Waffen() ) zuteuer=true;}
       else if(what==MBE_T::ZAUBER)
         { if((*i)->Lernpunkte() > vabenteurer->getLernpunkte().getLernpunkte().Zauber() ) zuteuer=true; }
       else if(what==MBE_T::FERTIGKEIT)
         { if((*i)->Lernpunkte() > vabenteurer->getLernpunkte().getLernpunkte().Fach() ) zuteuer=true; }

       if(zuteuer && !togglebutton_teure_anzeigen->get_active()) continue;
       if(gelernt && !togglebutton_gelernte_anzeigen->get_active()) continue;
       if(gelernt) (*i)->setGelernt(true);

       newlist.push_back(*i);
      }
     }
  MidgardBasicTree::show_list_in_tree(newlist,tree_lernschema,hauptfenster->getChar().actualIterator());
  tree_lernschema->show();
  scrolledwindow_lernen->add(*tree_lernschema);

  setTitels_for_Lernschema(what,liste);
  tree_lernschema->Expand_recursively();

  scrolledwindow_lernen->show();
}

void table_lernschema::setTitels_for_Lernschema(const MBE_T::MBEE& what,MBEm_T::wie_erlernt::lernen_t liste)
{
 std::vector<std::string> vs;
 vs.push_back("LP");
 switch (what) {
   case MBE_T::WAFFE:
     {
       vs.push_back("Grundkenntnnis"); // PFLICHTg
       vs.push_back("Waffe");
       vs.push_back("Wert");
       vs.push_back(""); // EIGENSCHAFTg
       vs.push_back("Voraussetzung");
       vs.push_back("Schwierigkeit");
       break;
     }
   case MBE_T::FERTIGKEIT:
     {
       vs.push_back("Pflicht");
       vs.push_back("Fertigkeit");
       vs.push_back("Wert");
       vs.push_back("L.E.");
       vs.push_back("Voraussetzung");
       vs.push_back("Kosten");
       break;
     }
   case MBE_T::ZAUBER:
     {
       vs.push_back("");
       vs.push_back("Zauber");
       vs.push_back("AP"); // WERTg
       vs.push_back("");
       vs.push_back("");
       vs.push_back("Kosten");
       break;
     }
   default: break;
   }
 vs.push_back("Art");
 vs.push_back("Gelernt");
 tree_lernschema->setTitles(vs);

 switch (what) {
   case MBE_T::WAFFE:
     {
       tree_lernschema->set_column_visibility(Data_SimpleTree::PFLICHTg,true);
       tree_lernschema->set_column_visibility(Data_SimpleTree::EIGENSCHAFTg,false);
       tree_lernschema->set_column_visibility(Data_SimpleTree::VORAUSSETZUNGg,true);
       tree_lernschema->set_column_visibility(Data_SimpleTree::KOSTENg,true);
       break;
     }
   case MBE_T::FERTIGKEIT:
     {
       if(liste==MBEm_T::wie_erlernt::fachkenntnis) tree_lernschema->set_column_visibility(Data_SimpleTree::PFLICHTg,true);
       else tree_lernschema->set_column_visibility(Data_SimpleTree::PFLICHTg,false);
       tree_lernschema->set_column_visibility(Data_SimpleTree::EIGENSCHAFTg,true);
       tree_lernschema->set_column_visibility(Data_SimpleTree::VORAUSSETZUNGg,true);
       tree_lernschema->set_column_visibility(Data_SimpleTree::KOSTENg,true);
       break;
     }
   case MBE_T::ZAUBER:
     {
       tree_lernschema->set_column_visibility(Data_SimpleTree::PFLICHTg,false);
       tree_lernschema->set_column_visibility(Data_SimpleTree::EIGENSCHAFTg,false);
       tree_lernschema->set_column_visibility(Data_SimpleTree::VORAUSSETZUNGg,false);
       tree_lernschema->set_column_visibility(Data_SimpleTree::KOSTENg,true);
       break;
     }
    default : break;
   }
}

void table_lernschema::clean_lernschema_trees()
{
  scrolledwindow_lernen->remove();
  tree_lernschema=0;
  Beruf_tree=0;
  tree_angeb_fert=0;
  tree_kido_lernschema=0;
  tree_waffen_lernschema=0;
}


