// $Id: export_common.cc,v 1.23 2003/09/01 06:47:59 christof Exp $
/*  Midgard Roleplaying Character Generator
 *  Copyright (C) 2001-2002 Christof Petig
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "export_common.h"
#include <Misc/itos.h>

std::string region;

#if defined( __MINGW32__) || defined(USE_XML)
#define NO_SQL
#endif

#ifndef NO_SQL
std::string toSQL(const std::string &s)
{  std::string res;
   for (std::string::const_iterator i=s.begin();i!=s.end();++i)
   {  if (*i=='\'') res+="''";
      else res+=*i;
//      else res+=std::string("\")+Formatiere(*i,0,3,"0");
   }
   return "'"+res+"'";
}

int fetch_int(Query::Row &is,int standard)
{  int val;
   
   is >> Query::Row::MapNull<int>(val,standard);
   return val;
}

int fetch_and_set_int_attrib(Query::Row &is,Tag &o,const std::string &wert,int standard)
{  int val=fetch_int(is,standard);
   if (val!=standard) o.setIntAttr(wert,val);
   return val;
}

double fetch_float(Query::Row &is,double standard)
{  float val;
   
   is >> Query::Row::MapNull<float>(val,standard);
   return val;
}

std::string fetch_string(Query::Row &is,const std::string &standard)
{  std::string val;
   
   is >> Query::Row::MapNull<std::string>(val,standard); 
   return val;
}

std::string fetch_and_set_string_attrib(Query::Row &is,Tag &o,const std::string &wert,const std::string &standard)
{  std::string val=fetch_string(is,standard);
   if (val!=standard) o.setAttr(wert,val);
   return val;
}

bool fetch_and_set_bool_attrib(Query::Row &is,Tag &o,const std::string &wert,bool standard)
{  bool val=fetch_bool(is,standard);
   if (val!=standard) o.setBoolAttr(wert,val);
   return val;
}

double fetch_and_set_float_attrib(Query::Row &is,Tag &o,const std::string &wert,double standard)
{  double val=fetch_float(is,standard);
   if (val!=standard) o.setAttr(wert,dtos(val));
   return val;
}

bool fetch_bool(Query::Row &is,const bool &standard)
{  bool val;
   
   is >> Query::Row::MapNull<bool>(val,standard); 
   return val;
}

#endif

